package com.zhiqiyun.open.mvc.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zhiqiyun.open.annotation.Permission;
import com.zhiqiyun.open.core.models.bz.BaseDataInfo;
import com.zhiqiyun.open.core.models.bz.VenueInfo;
import com.zhiqiyun.open.core.models.user.OauthInfo;
import com.zhiqiyun.open.core.service.OauthService;
import com.zhiqiyun.open.core.service.SequenceService;
import com.zhiqiyun.open.core.service.VenueInfoService;
import com.zhiqiyun.open.mvc.Result;
import com.zhiqiyun.open.mvc.params.bz.QueryVenueInfoParams;
import com.zhiqiyun.open.mvc.params.bz.SaveVenueInfoParams;
import com.zhiqiyun.open.utils.DateUtil;
import com.zhiqiyun.open.utils.ServletContext;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

@Slf4j
@RestController
@RequestMapping("/bz/base/venue")
public class VenueInfoController {

    @Autowired
    private VenueInfoService venueInfoService;

    @Autowired
    private SequenceService sequenceService;

    @Autowired
    private OauthService oauthService;

    @Permission(value = "bz.base.venue.find", tags = "查询场馆")
    @PostMapping("/findPage")
    public Result findPage(@RequestBody QueryVenueInfoParams params) {
        QueryWrapper<VenueInfo> queryWrapper = new QueryWrapper<>();
        if (StringUtils.isNotBlank(params.getKeyword())) {
            StringBuilder sb = new StringBuilder("select id from bz_base_info where");
            sb.append(" name like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or brief like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or address like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or contacts like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or contact_number like ").append("'%").append(params.getKeyword()).append("%'");
            queryWrapper.inSql("id", sb.toString());
        }

        Page<VenueInfo> page = params.getPage();
        page.addOrder(OrderItem.desc("id"));

        Page<VenueInfo> resultData = this.venueInfoService.page(page, queryWrapper);

        return Result.instance(Result.Code.SUCCESS).setData(resultData);
    }

    @Permission(value = "bz.base.venue.add", tags = "保存场馆")
    @PostMapping("/save")
    public Result save(@Valid @RequestBody SaveVenueInfoParams params) {

        this.venueInfoService.save(this.buildEntity(this.sequenceService.nextId(), params));

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "bz.base.venue.edit", tags = "编辑场馆")
    @PostMapping("/updateById")
    public Result updateById(Long id, @Valid @RequestBody SaveVenueInfoParams params) {

        this.venueInfoService.updateById(this.buildEntity(id, params));

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }


    private VenueInfo buildEntity(Long id, @Valid SaveVenueInfoParams params) {

        VenueInfo entity = new VenueInfo();
        BaseDataInfo baseDataInfo = new BaseDataInfo();

        BeanUtils.copyProperties(params, entity);
        BeanUtils.copyProperties(params.getBaseDataInfo(), baseDataInfo);


        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        baseDataInfo.setCreatedTime(DateUtil.current());
        baseDataInfo.setUpdatedTime(DateUtil.current());
        baseDataInfo.setCreatedBy(oauthInfo.getId());
        baseDataInfo.setUpdatedBy(oauthInfo.getId());

        entity.setBaseDataInfo(baseDataInfo);
        entity.setId(id);
        return entity;
    }

    @Permission(value = "bz.base.venue.delete", tags = "删除场馆")
    @PostMapping("/deleteByIds")
    public Result deleteByIds(@RequestBody List<Long> ids) {
        this.venueInfoService.removeByIds(ids);
        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }
}
